<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSubGroupResultV2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfSubGroupResultV2 extends AbstractStructArrayBase
{
    /**
     * The SubGroupResultV2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SubGroupResultV2[]
     */
    public $SubGroupResultV2;
    /**
     * Constructor method for ArrayOfSubGroupResultV2
     * @uses ArrayOfSubGroupResultV2::setSubGroupResultV2()
     * @param \StructType\SubGroupResultV2[] $subGroupResultV2
     */
    public function __construct(array $subGroupResultV2 = array())
    {
        $this
            ->setSubGroupResultV2($subGroupResultV2);
    }
    /**
     * Get SubGroupResultV2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SubGroupResultV2[]|null
     */
    public function getSubGroupResultV2()
    {
        return isset($this->SubGroupResultV2) ? $this->SubGroupResultV2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSubGroupResultV2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSubGroupResultV2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSubGroupResultV2ForArrayConstraintsFromSetSubGroupResultV2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSubGroupResultV2SubGroupResultV2Item) {
            // validation for constraint: itemType
            if (!$arrayOfSubGroupResultV2SubGroupResultV2Item instanceof \StructType\SubGroupResultV2) {
                $invalidValues[] = is_object($arrayOfSubGroupResultV2SubGroupResultV2Item) ? get_class($arrayOfSubGroupResultV2SubGroupResultV2Item) : sprintf('%s(%s)', gettype($arrayOfSubGroupResultV2SubGroupResultV2Item), var_export($arrayOfSubGroupResultV2SubGroupResultV2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SubGroupResultV2 property can only contain items of type \StructType\SubGroupResultV2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SubGroupResultV2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SubGroupResultV2[] $subGroupResultV2
     * @return \ArrayType\ArrayOfSubGroupResultV2
     */
    public function setSubGroupResultV2(array $subGroupResultV2 = array())
    {
        // validation for constraint: array
        if ('' !== ($subGroupResultV2ArrayErrorMessage = self::validateSubGroupResultV2ForArrayConstraintsFromSetSubGroupResultV2($subGroupResultV2))) {
            throw new \InvalidArgumentException($subGroupResultV2ArrayErrorMessage, __LINE__);
        }
        if (is_null($subGroupResultV2) || (is_array($subGroupResultV2) && empty($subGroupResultV2))) {
            unset($this->SubGroupResultV2);
        } else {
            $this->SubGroupResultV2 = $subGroupResultV2;
        }
        return $this;
    }
    /**
     * Add item to SubGroupResultV2 value
     * @throws \InvalidArgumentException
     * @param \StructType\SubGroupResultV2 $item
     * @return \ArrayType\ArrayOfSubGroupResultV2
     */
    public function addToSubGroupResultV2(\StructType\SubGroupResultV2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SubGroupResultV2) {
            throw new \InvalidArgumentException(sprintf('The SubGroupResultV2 property can only contain items of type \StructType\SubGroupResultV2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SubGroupResultV2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SubGroupResultV2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SubGroupResultV2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SubGroupResultV2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SubGroupResultV2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SubGroupResultV2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SubGroupResultV2
     */
    public function getAttributeName()
    {
        return 'SubGroupResultV2';
    }
}
